#ifndef DIYA_SHELL_H
#define DIYA_SHELL_H
#include <gtk4-layer-shell.h>
#include "base.h"

enum diya_win_state
{
    DIYA_WIN_STATE_NONE = 0,
    DIYA_WIN_STATE_MINIMIZE = 1 << 0,
    DIYA_WIN_STATE_MAXIMIZE = 1 << 1,
    DIYA_WIN_STATE_FULLSCREEN = 1 << 2,
    DIYA_WIN_STATE_FOCUS = 1 << 3,
};

#define DIYA_TYPE_SHELL (diya_shell_get_type ())
G_DECLARE_FINAL_TYPE (DiyaShell, diya_shell, DIYA, SHELL, DiyaObject)

#define DIYA_TYPE_WAYLAND (diya_wayland_get_type ())
G_DECLARE_FINAL_TYPE (DiyaWayland, diya_wayland, DIYA, WAYLAND, DiyaShellObject)

#define DIYA_TYPE_FOREIGN_WINDOW (diya_foreign_window_get_type ())
G_DECLARE_FINAL_TYPE (DiyaForeignWindow, diya_foreign_window, DIYA, FOREIGN_WINDOW, DiyaShellObject)

#define DIYA_TYPE_LOCK_SESSION (diya_lock_session_get_type ())
G_DECLARE_FINAL_TYPE (DiyaLockSession, diya_lock_session, DIYA, LOCK_SESSION, DiyaShellObject)


DiyaForeignWindow* diya_shell_get_window(DiyaShell * shell, gpointer handle);
gboolean diya_shell_add_window(DiyaShell * shell, DiyaForeignWindow * win);
gboolean diya_shell_remove_window(DiyaShell * shell, DiyaForeignWindow * win);
void diya_shell_remove_all_windows(DiyaShell * shell);

DiyaShell * diya_shell_new(GtkApplication * app);
DiyaWayland * diya_shell_get_wayland(DiyaShell* shell);
#endif